/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include "algostuff.hpp"
using namespace std;

int main()
{
    vector<int> coll;

    INSERT_ELEMENTS(coll,1,9);
    PRINT_ELEMENTS(coll);

    // oblicz sumę elementów
    cout << "sum: "
         << accumulate (coll.cbegin(), coll.cend(),  // zakres
                        0)                           // wartość początkowa
         << endl;

    // oblicz sumę elementów minus 100
    cout << "sum: "
         << accumulate (coll.cbegin(), coll.cend(),  // zakres
                        -100)                        // wartość początkowa
         << endl;

    // oblicz iloczyn elementów
    cout << "product: "
         << accumulate (coll.cbegin(), coll.cend(),  // zakres
                        1,                           // wartość początkowa
                        multiplies<int>())           // operacja
         << endl;

    // oblicz iloczyn elementów (jako wartość początkową zastosuj 0)
    cout << "product: "
         << accumulate (coll.cbegin(), coll.cend(),  // zakres
                        0,                           // wartość początkowa
                        multiplies<int>())           // operacja
         << endl;
}
