/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include "algostuff.hpp"
using namespace std;

bool differenceOne (int elem1, int elem2)
{
    return elem1 + 1 == elem2 || elem1 - 1 == elem2;
}

int main()
{
    // dane zrodlowe
    int source[] = { 1, 4, 4, 6, 1, 2, 2, 3, 1, 6, 6, 6, 5, 7,
                      5, 4, 4 };

    // zainicjalizuj kolekcje coll elementami z tablicy source
    list<int> coll;
    copy(begin(source), end(source),    // zrodlo
         back_inserter(coll));          // przeznaczenie
    PRINT_ELEMENTS(coll);

    // wypisz elementy z usunietymi kolejnymi powtorzeniami
    unique_copy(coll.cbegin(), coll.cend(),        // zrodlo
                ostream_iterator<int>(cout," "));  // przeznaczenie
    cout << endl;

    // wypisz elementy bez kolejnych pozycji rozniacych sie o jeden
    unique_copy(coll.cbegin(), coll.cend(),       // zrodlo
                ostream_iterator<int>(cout," "),  // przeznaczenie
                differenceOne);                   // kryterium powtorzenia
    cout << endl;
}
