/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include <streambuf>
#include <locale>
#include <cstdio>

class outbuf : public std::streambuf
{
  protected:
    // główna funkcja wyjściowa
    // - wyświetla znaki w trybie uppercase 
    virtual int_type overflow (int_type c) {
        if (c != EOF) {
            // konwertuje małe litery na duże
            c = std::toupper(c,getloc());

            // i zapisuje znak na standardowe wyjście
            if (std::putchar(c) == EOF) {
                return EOF;
            }
        }
        return c;
    }
};
