/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include <iostream>
#include <sstream>
#include <string>
#include <tuple>
#include <utility>
using namespace std;

tuple<string,string,string> parseName(string name)
{
    string s1, s2, s3;
    istringstream(name) >> s1 >> s2 >> s3;
    if (s3.empty()) {
        return tuple<string,string,string>(move(s1),"",move(s2));
    }
    else {
        return tuple<string,string,string>(move(s1),move(s2),move(s3));
    }
}

int main()
{
    auto t1 = parseName("Nicolai M. Josuttis");    
    cout << "imię: " << get<0>(t1) << endl;
    cout << "drugie imię: " << get<1>(t1) << endl;
    cout << "nazwisko: " << get<2>(t1) << endl;
    auto t2 = parseName("Nico Josuttis");
    cout << "imię: " << get<0>(t2) << endl;
    cout << "drugie imię: " << get<1>(t2) << endl;
    cout << "nazwisko: " << get<2>(t2) << endl;
}
