/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include <string>
#include <regex>
#include <iostream>
using namespace std;

int main()
{
    // wyszukiwanie bez rozpoznawania wielkości liter haseł skorowidza LaTeX 
    string pat1 = R"(\\.*index\{([^}]*)\})"; // pierwsza grupa przechwytywania
    string pat2 = R"(\\.*index\{(.*)\}\{(.*)\})"; // 2ga i 3cia grupa przechwytywania
    regex pat (pat1+"\n"+pat2,
               regex_constants::egrep|regex_constants::icase);
    // zainicjowanie ciągu znakami ze standardowego wejścia:
    string data((istreambuf_iterator<char>(cin)),
                istreambuf_iterator<char>());
    // wyszukiwanie i wyświetlanie pasujących haseł skorowidza:
    smatch m;
    auto pos = data.cbegin();
    auto end = data.cend();
    for ( ; regex_search (pos,end,m,pat); pos=m.suffix().first) {
        cout << "dopasowanie: " << m.str() << endl;
        cout << " wartość: " << m.str(1)+m.str(2) << endl;
        cout << " zobacz też: " << m.str(3) << endl;
    }
}
