/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include <unordered_set>
#include <string>
#include <iostream>
using namespace std;

int main()
{
    unordered_multiset<string> cities {
        "Hanover", "Chicago", "Frankfurt", "Nowy Jork",
        "Toronto", "Londyn", "Frankfurt"
    };

    // wypisz wszystkie elementy:
    for (const auto& elem : cities) {
        cout << elem << " ";
    }
    cout << endl;

    // wstaw dodatkowe wartości:
    cities.insert( {"Los Angeles", "Monachium", "Hanover", "Londyn"} );
    // wypisz wszystkie elementy:
    for (const auto& elem : cities) {
        cout << elem << " ";
    }
    cout << endl;
}
